/*
  Lexical analyzer returns a double floating point
  number on the stack and the token NUM, or the ASCII
  character read if not a number.  Skips all blanks
  and tabs, returns 0 for EOF. 
*/

#include <stdio.h>
#include "rpn.tab.h"

yylex ()
{
  int c;
  
  /* skip white space  */
  while ((c = getchar ()) == ' ' || c == '\t');
  
  /* process numbers   */
  if (c == '.' || isdigit (c))
    {
      ungetc (c, stdin);
      scanf ("%lf", &yylval);
      return NUM;
    }

  /* return end-of-file  */
  if (c == EOF)
    return 0;
  
  /* return single chars */
  return c;
}

