/* Reverse polish notation calculator. */
     
%{

  #define YYSTYPE double
  #include <stdio.h>
  #include <math.h>


  void yyerror(char *s)
  {
    printf("%s\n",s); 
  }
%}

     
%token NUM
     
%% /* Grammar rules and actions follow */

input:    /* empty */
         | input line
;

line: '\n'
      | exp '\n'  { printf ("\t%.10g\n", $1); }
;
     
exp:      NUM             { $$ = $1;         }
| exp exp '+'     { $$ = $1 + $2;    }
| exp exp '-'     { $$ = $1 - $2;    }
| exp exp '*'     { $$ = $1 * $2;    }
| exp exp '/'     { $$ = $1 / $2;    }
/* Exponentiation */
| exp exp '^'     { $$ = pow ($1, $2); }
/* Unary minus    */
| exp 'n'         { $$ = -$1;        }
     ;

%%

main ()
{
  yyparse ();
}



