%option noyywrap

%{

#include <stdio.h>
#include <string.h>
#include "tree.h"
#include "treeparser.tab.h"

int linenum=1;
int colnum=0;

%}

%%

"TREE"      colnum+=strlen(yytext); return TREE;

"("             colnum++; return LPAR;
")"             colnum++; return RPAR;
   
[0-9A-Za-z]+ { 
                 yylval.s=strdup(yytext); colnum+=strlen(yytext); return LABEL;
             }

"%"(.*)"\n"             linenum++; colnum=0;

(" "|\t)*	        colnum+=strlen(yytext);

"\n"			linenum++; colnum=0;

.			fprintf(stderr,"Unknown symbol: <%s>\n",yytext); colnum++;






